﻿namespace MetaTrader {

	using System;
	using System.Reflection;
	using XNSNET.Collections;

	public class SessionCollection: TemplatedList<SessionCollection, Session> {

		internal readonly Claster Claster;

		internal SessionCollection( Claster iClaster ) : base() {
			Claster = iClaster;
		}

		public Session this[ Context iContext ] {
			get {
				Session _Next = this.First;
				Session _Item;
				while ( _Next != null ) {
					_Item = _Next;
					_Next = _Next.Next;
					if ( _Item.Context == iContext )
						return _Item;
				}
				return null;
			}
		}

		public Session Append( Context iContext ) {
			if ( iContext == null )
				throw new ArgumentNullException();
			Session _Item = this[ iContext ];
			if ( _Item != null ) return _Item;
			return AddFinal( new Session( iContext ) );
		}

		public Session Remove( Context iContext ) {
			if ( iContext == null )
				throw new ArgumentNullException();
			Session _Item = this[ iContext ];
			if ( _Item != null ) {
				Remove( _Item );
			}
			return _Item;
		}

	}

	public class Session: TemplatedItem<SessionCollection, Session> {

		public readonly Context Context;

		internal Session( Context iContext )
			: base() {
			Context = iContext;
		}

		public override void OnAdded() {
			Context.mClaster = this.List.Claster;
		}

		public override void OnRemoved() {
			Context.mClaster = null;
		}

	}

}