using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MetaTrader.Windows {
	public partial class WindowSymbols: Form {
		public WindowSymbols() {
			InitializeComponent();
		}

		private void WindowClasters_Load( object sender, EventArgs e ) {
			Output();
		}

		private void timer1_Tick( object sender, EventArgs e ) {
			SymbolList.Items.Clear();
			Output();
		}

		private void Output() {
			foreach ( Claster item in Global.Claster.Array ) {
				string up = item.Up != null ? item.Up.ToString() : "";
				string down = item.Down != null ? item.Down.ToString() : "";
				if ( item.Ticks.Count > 0 ) {
					ClasterTick _Now = item.Ticks.Final;
					if ( _Now is ClasterTickValue ) {
						SymbolList.Items.Add( new ListViewItem( new string[] { item.Symbol, up, down, item.Session.Count.ToString(), item.Ticks.Count.ToString( "###.###" ), _Now.Bid.ToString(), _Now.Ask.ToString(), _Now.CalledStamp.ToString(), _Now.ServerStamp.ToString() }, 0 ) );
					} else if ( _Now is ClasterTickSpace ) {
						SymbolList.Items.Add( new ListViewItem( new string[] { item.Symbol, up, down, item.Session.Count.ToString(), item.Ticks.Count.ToString( "###.###" ), "space", "space", _Now.CalledStamp.ToString(), "space" }, 0 ) );
					}
				} else {
					SymbolList.Items.Add( new ListViewItem( new string[] { item.Symbol, up, down, item.Session.Count.ToString(), item.Ticks.Count.ToString( "###.###" ) }, 0 ) );
				}
			}
		}
		
	}
}